<h1 align="center">
  <a href="https://usebeagle.io/">
    Beagle
  </a>
</h1>

<p align="center">
  <a href="https://github.com/ZupIT/beagle/blob/master/LICENSE">
    <img src="https://img.shields.io/badge/License-Apache%202.0-blue.svg" alt="Beagle is released under the Apache 2.0 license." />
  </a>
  <a href="https://github.com/ZupIT/beagle/actions?query=workflow%3A%22Beagle+Release%22">
    <img src="https://github.com/ZupIT/beagle/workflows/Beagle%20Release/badge.svg" alt="Current GIthub Actionbuild status." />
  </a>
  <a href="https://github.com/ZupIT/beagle/blob/master/CONTRIBUTING.md">
    <img src="https://img.shields.io/badge/PRs-welcome-brightgreen.svg" alt="PRs welcome!" />
  </a>
</p>

<h3 align="center">
  <a href="https://docs.usebeagle.io/primeiros-passos/instalando-beagle">Getting Started</a>
  <span> · </span>
  <a href="https://docs.usebeagle.io/primeiros-passos/usando-beagle">Learn the Basics</a>
  <span> · </span>
  <a href="https://docs.usebeagle.io/primeiros-passos/user-cases">Showcase</a>
  <span> · </span>
  <a href="https://github.com/ZupIT/beagle/blob/master/CONTRIBUTING.md">Contribute</a>
</h3>

Beagle is an **open source framework** for **cross-platform** development using the concept of Server-Driven UI.

This framework allow teams to build and alter layouts and data directly through a backend but yet displaying its contents natively in a mobile application and / or through web.

It is also possible to create, test and update native application components and screen paths without the need update the mobile application at the store (App Store or Play Store).

## Contents

- [Requirements](#-requirements)
- [Building your first app using beagle](#-building-your-first-app-using-beagle)
- [Documentation](#-documentation)
- [Upgrading](#-upgrading)
- [How to Contribute](#-how-to-contribute)
- [Code of Conduct](#code-of-conduct)
- [License](#-license)

## 📋 Requirements

Beagle apps may target iOS 10.0 and Android 4.4 (API 19) or newer. You may use Windows, macOS, or Linux as your development operating system.

## 🎉 Building your first app using beagle

Follow the [Getting Started guide](https://docs.usebeagle.io/primeiros-passos/instalando-beagle). The recommended way to install Beagle depends on your project. Here you can find short guides for the most common scenarios:

- [Creating a New Application][new-app]
- [Adding Beagle to an Existing Application][existing]

[new-app]: https://docs.usebeagle.io/primeiros-passos/usando-beagle
[existing]: https://docs.usebeagle.io/primeiros-passos/usando-beagle

## 📖 Documentation

The full documentation for Begle can be found on our [website][docs].

The Beagle documentation discusses components, APIs, and topics that are specific to Beagle. [Beagle documentation][b-docs].

The source for the Beagle documentation and website is hosted on a separate repo, [**@beagle site**][repo-website].

[docs]: https://docs.usebeagle.io/
[b-docs]: https://docs.usebeagle.io/primeiros-passos/instalando-beagle
[repo-website]: https://usebeagle.io/


## 👏 How to Contribute

The main purpose of this repository is to continue evolving Beagle core. We want to make contributing to this project as easy and transparent as possible, and we are grateful to the community for contributing bug fixes and improvements. Read below to learn how you can take part in improving Begle.

### [Contributing Guide][contribute]

Read our [**Contributing Guide**][contribute] to learn about our development process, how to propose bugfixes and improvements, and how to build and test your changes to Beagle.

[contribute]: https://github.com/ZupIT/beagle/blob/master/CONTRIBUTING.md

### [Open Source Roadmap][roadmap]

You can learn more about our vision for beagle in the [**Roadmap**][roadmap].

[roadmap]: https://github.com/ZupIT/beagle/milestones

### Good First Issues

We have a list of [good first issues][gfi] that contain bugs which have a relatively limited scope. This is a great place to get started, gain experience, and get familiar with our contribution process.

[gfi]: https://github.com/ZupIT/beagle/issues?q=is%3Aissue+is%3Aopen+label%3A%22good+first+issue%22

## 📄 License

Beagle is Apache 2.0 licensed, as found in the [LICENSE][l] file.

[l]: https://github.com/ZupIT/beagle/blob/master/LICENSE.txt